/**
 * Copyright (C) 2020-2022 Dušan Vejnović <vaadin@dussan.org>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.dussan.vaadin.dvirtual.icons;

import com.vaadin.flow.component.icon.Icon;

public enum IcomoonIcon
{

    HOME( "home" ),
    HOME2( "home2" ),
    HOME3( "home3" ),
    OFFICE( "office" ),
    NEWSPAPER( "newspaper" ),
    PENCIL( "pencil" ),
    PENCIL2( "pencil2" ),
    QUILL( "quill" ),
    PEN( "pen" ),
    BLOG( "blog" ),
    EYEDROPPER( "eyedropper" ),
    DROPLET( "droplet" ),
    PAINT_FORMAT( "paint-format" ),
    IMAGE( "image" ),
    IMAGES( "images" ),
    CAMERA( "camera" ),
    HEADPHONES( "headphones" ),
    MUSIC( "music" ),
    PLAY( "play" ),
    FILM( "film" ),
    VIDEO_CAMERA( "video-camera" ),
    DICE( "dice" ),
    PACMAN( "pacman" ),
    SPADES( "spades" ),
    CLUBS( "clubs" ),
    DIAMONDS( "diamonds" ),
    BULLHORN( "bullhorn" ),
    CONNECTION( "connection" ),
    PODCAST( "podcast" ),
    FEED( "feed" ),
    MIC( "mic" ),
    BOOK( "book" ),
    BOOKS( "books" ),
    LIBRARY( "library" ),
    FILE_TEXT( "file-text" ),
    PROFILE( "profile" ),
    FILE_EMPTY( "file-empty" ),
    FILES_EMPTY( "files-empty" ),
    FILE_TEXT2( "file-text2" ),
    FILE_PICTURE( "file-picture" ),
    FILE_MUSIC( "file-music" ),
    FILE_PLAY( "file-play" ),
    FILE_VIDEO( "file-video" ),
    FILE_ZIP( "file-zip" ),
    COPY( "copy" ),
    PASTE( "paste" ),
    STACK( "stack" ),
    FOLDER( "folder" ),
    FOLDER_OPEN( "folder-open" ),
    FOLDER_PLUS( "folder-plus" ),
    FOLDER_MINUS( "folder-minus" ),
    FOLDER_DOWNLOAD( "folder-download" ),
    FOLDER_UPLOAD( "folder-upload" ),
    PRICE_TAG( "price-tag" ),
    PRICE_TAGS( "price-tags" ),
    BARCODE( "barcode" ),
    QRCODE( "qrcode" ),
    TICKET( "ticket" ),
    CART( "cart" ),
    COIN_DOLLAR( "coin-dollar" ),
    COIN_EURO( "coin-euro" ),
    COIN_POUND( "coin-pound" ),
    COIN_YEN( "coin-yen" ),
    CREDIT_CARD( "credit-card" ),
    CALCULATOR( "calculator" ),
    LIFEBUOY( "lifebuoy" ),
    PHONE( "phone" ),
    PHONE_HANG_UP( "phone-hang-up" ),
    ADDRESS_BOOK( "address-book" ),
    ENVELOP( "envelop" ),
    PUSHPIN( "pushpin" ),
    LOCATION( "location" ),
    LOCATION2( "location2" ),
    COMPASS( "compass" ),
    COMPASS2( "compass2" ),
    MAP( "map" ),
    MAP2( "map2" ),
    HISTORY( "history" ),
    CLOCK( "clock" ),
    CLOCK2( "clock2" ),
    ALARM( "alarm" ),
    BELL( "bell" ),
    STOPWATCH( "stopwatch" ),
    CALENDAR( "calendar" ),
    PRINTER( "printer" ),
    KEYBOARD( "keyboard" ),
    DISPLAY( "display" ),
    LAPTOP( "laptop" ),
    MOBILE( "mobile" ),
    MOBILE2( "mobile2" ),
    TABLET( "tablet" ),
    TV( "tv" ),
    DRAWER( "drawer" ),
    DRAWER2( "drawer2" ),
    BOX_ADD( "box-add" ),
    BOX_REMOVE( "box-remove" ),
    DOWNLOAD( "download" ),
    UPLOAD( "upload" ),
    FLOPPY_DISK( "floppy-disk" ),
    DRIVE( "drive" ),
    DATABASE( "database" ),
    UNDO( "undo" ),
    REDO( "redo" ),
    UNDO2( "undo2" ),
    REDO2( "redo2" ),
    FORWARD( "forward" ),
    REPLY( "reply" ),
    BUBBLE( "bubble" ),
    BUBBLES( "bubbles" ),
    BUBBLES2( "bubbles2" ),
    BUBBLE2( "bubble2" ),
    BUBBLES3( "bubbles3" ),
    BUBBLES4( "bubbles4" ),
    USER( "user" ),
    USERS( "users" ),
    USER_PLUS( "user-plus" ),
    USER_MINUS( "user-minus" ),
    USER_CHECK( "user-check" ),
    USER_TIE( "user-tie" ),
    QUOTES_LEFT( "quotes-left" ),
    QUOTES_RIGHT( "quotes-right" ),
    HOUR_GLASS( "hour-glass" ),
    SPINNER( "spinner" ),
    SPINNER2( "spinner2" ),
    SPINNER3( "spinner3" ),
    SPINNER4( "spinner4" ),
    SPINNER5( "spinner5" ),
    SPINNER6( "spinner6" ),
    SPINNER7( "spinner7" ),
    SPINNER8( "spinner8" ),
    SPINNER9( "spinner9" ),
    SPINNER10( "spinner10" ),
    SPINNER11( "spinner11" ),
    BINOCULARS( "binoculars" ),
    SEARCH( "search" ),
    ZOOM_IN( "zoom-in" ),
    ZOOM_OUT( "zoom-out" ),
    ENLARGE( "enlarge" ),
    SHRINK( "shrink" ),
    ENLARGE2( "enlarge2" ),
    SHRINK2( "shrink2" ),
    KEY( "key" ),
    KEY2( "key2" ),
    LOCK( "lock" ),
    UNLOCKED( "unlocked" ),
    WRENCH( "wrench" ),
    EQUALIZER( "equalizer" ),
    EQUALIZER2( "equalizer2" ),
    COG( "cog" ),
    COGS( "cogs" ),
    HAMMER( "hammer" ),
    MAGIC_WAND( "magic-wand" ),
    AID_KIT( "aid-kit" ),
    BUG( "bug" ),
    PIE_CHART( "pie-chart" ),
    STATS_DOTS( "stats-dots" ),
    STATS_BARS( "stats-bars" ),
    STATS_BARS2( "stats-bars2" ),
    TROPHY( "trophy" ),
    GIFT( "gift" ),
    GLASS( "glass" ),
    GLASS2( "glass2" ),
    MUG( "mug" ),
    SPOON_KNIFE( "spoon-knife" ),
    LEAF( "leaf" ),
    ROCKET( "rocket" ),
    METER( "meter" ),
    METER2( "meter2" ),
    HAMMER2( "hammer2" ),
    FIRE( "fire" ),
    LAB( "lab" ),
    MAGNET( "magnet" ),
    BIN( "bin" ),
    BIN2( "bin2" ),
    BRIEFCASE( "briefcase" ),
    AIRPLANE( "airplane" ),
    TRUCK( "truck" ),
    ROAD( "road" ),
    ACCESSIBILITY( "accessibility" ),
    TARGET( "target" ),
    SHIELD( "shield" ),
    POWER( "power" ),
    SWITCH( "switch" ),
    POWER_CORD( "power-cord" ),
    CLIPBOARD( "clipboard" ),
    LIST_NUMBERED( "list-numbered" ),
    LIST( "list" ),
    LIST2( "list2" ),
    TREE( "tree" ),
    MENU( "menu" ),
    MENU2( "menu2" ),
    MENU3( "menu3" ),
    MENU4( "menu4" ),
    CLOUD( "cloud" ),
    CLOUD_DOWNLOAD( "cloud-download" ),
    CLOUD_UPLOAD( "cloud-upload" ),
    CLOUD_CHECK( "cloud-check" ),
    DOWNLOAD2( "download2" ),
    UPLOAD2( "upload2" ),
    DOWNLOAD3( "download3" ),
    UPLOAD3( "upload3" ),
    SPHERE( "sphere" ),
    EARTH( "earth" ),
    LINK( "link" ),
    FLAG( "flag" ),
    ATTACHMENT( "attachment" ),
    EYE( "eye" ),
    EYE_PLUS( "eye-plus" ),
    EYE_MINUS( "eye-minus" ),
    EYE_BLOCKED( "eye-blocked" ),
    BOOKMARK( "bookmark" ),
    BOOKMARKS( "bookmarks" ),
    SUN( "sun" ),
    CONTRAST( "contrast" ),
    BRIGHTNESS_CONTRAST( "brightness-contrast" ),
    STAR_EMPTY( "star-empty" ),
    STAR_HALF( "star-half" ),
    STAR_FULL( "star-full" ),
    HEART( "heart" ),
    HEART_BROKEN( "heart-broken" ),
    MAN( "man" ),
    WOMAN( "woman" ),
    MAN_WOMAN( "man-woman" ),
    HAPPY( "happy" ),
    HAPPY2( "happy2" ),
    SMILE( "smile" ),
    SMILE2( "smile2" ),
    TONGUE( "tongue" ),
    TONGUE2( "tongue2" ),
    SAD( "sad" ),
    SAD2( "sad2" ),
    WINK( "wink" ),
    WINK2( "wink2" ),
    GRIN( "grin" ),
    GRIN2( "grin2" ),
    COOL( "cool" ),
    COOL2( "cool2" ),
    ANGRY( "angry" ),
    ANGRY2( "angry2" ),
    EVIL( "evil" ),
    EVIL2( "evil2" ),
    SHOCKED( "shocked" ),
    SHOCKED2( "shocked2" ),
    BAFFLED( "baffled" ),
    BAFFLED2( "baffled2" ),
    CONFUSED( "confused" ),
    CONFUSED2( "confused2" ),
    NEUTRAL( "neutral" ),
    NEUTRAL2( "neutral2" ),
    HIPSTER( "hipster" ),
    HIPSTER2( "hipster2" ),
    WONDERING( "wondering" ),
    WONDERING2( "wondering2" ),
    SLEEPY( "sleepy" ),
    SLEEPY2( "sleepy2" ),
    FRUSTRATED( "frustrated" ),
    FRUSTRATED2( "frustrated2" ),
    CRYING( "crying" ),
    CRYING2( "crying2" ),
    POINT_UP( "point-up" ),
    POINT_RIGHT( "point-right" ),
    POINT_DOWN( "point-down" ),
    POINT_LEFT( "point-left" ),
    WARNING( "warning" ),
    NOTIFICATION( "notification" ),
    QUESTION( "question" ),
    PLUS( "plus" ),
    MINUS( "minus" ),
    INFO( "info" ),
    CANCEL_CIRCLE( "cancel-circle" ),
    BLOCKED( "blocked" ),
    CROSS( "cross" ),
    CHECKMARK( "checkmark" ),
    CHECKMARK2( "checkmark2" ),
    SPELL_CHECK( "spell-check" ),
    ENTER( "enter" ),
    EXIT( "exit" ),
    PLAY2( "play2" ),
    PAUSE( "pause" ),
    STOP( "stop" ),
    PREVIOUS( "previous" ),
    NEXT( "next" ),
    BACKWARD( "backward" ),
    FORWARD2( "forward2" ),
    PLAY3( "play3" ),
    PAUSE2( "pause2" ),
    STOP2( "stop2" ),
    BACKWARD2( "backward2" ),
    FORWARD3( "forward3" ),
    FIRST( "first" ),
    LAST( "last" ),
    PREVIOUS2( "previous2" ),
    NEXT2( "next2" ),
    EJECT( "eject" ),
    VOLUME_HIGH( "volume-high" ),
    VOLUME_MEDIUM( "volume-medium" ),
    VOLUME_LOW( "volume-low" ),
    VOLUME_MUTE( "volume-mute" ),
    VOLUME_MUTE2( "volume-mute2" ),
    VOLUME_INCREASE( "volume-increase" ),
    VOLUME_DECREASE( "volume-decrease" ),
    LOOP( "loop" ),
    LOOP2( "loop2" ),
    INFINITE( "infinite" ),
    SHUFFLE( "shuffle" ),
    ARROW_UP_LEFT( "arrow-up-left" ),
    ARROW_UP( "arrow-up" ),
    ARROW_UP_RIGHT( "arrow-up-right" ),
    ARROW_RIGHT( "arrow-right" ),
    ARROW_DOWN_RIGHT( "arrow-down-right" ),
    ARROW_DOWN( "arrow-down" ),
    ARROW_DOWN_LEFT( "arrow-down-left" ),
    ARROW_LEFT( "arrow-left" ),
    ARROW_UP_LEFT2( "arrow-up-left2" ),
    ARROW_UP2( "arrow-up2" ),
    ARROW_UP_RIGHT2( "arrow-up-right2" ),
    ARROW_RIGHT2( "arrow-right2" ),
    ARROW_DOWN_RIGHT2( "arrow-down-right2" ),
    ARROW_DOWN2( "arrow-down2" ),
    ARROW_DOWN_LEFT2( "arrow-down-left2" ),
    ARROW_LEFT2( "arrow-left2" ),
    CIRCLE_UP( "circle-up" ),
    CIRCLE_RIGHT( "circle-right" ),
    CIRCLE_DOWN( "circle-down" ),
    CIRCLE_LEFT( "circle-left" ),
    TAB( "tab" ),
    MOVE_UP( "move-up" ),
    MOVE_DOWN( "move-down" ),
    SORT_ALPHA_ASC( "sort-alpha-asc" ),
    SORT_ALPHA_DESC( "sort-alpha-desc" ),
    SORT_NUMERIC_ASC( "sort-numeric-asc" ),
    SORT_NUMBERIC_DESC( "sort-numberic-desc" ),
    SORT_AMOUNT_ASC( "sort-amount-asc" ),
    SORT_AMOUNT_DESC( "sort-amount-desc" ),
    COMMAND( "command" ),
    SHIFT( "shift" ),
    CTRL( "ctrl" ),
    OPT( "opt" ),
    CHECKBOX_CHECKED( "checkbox-checked" ),
    CHECKBOX_UNCHECKED( "checkbox-unchecked" ),
    RADIO_CHECKED( "radio-checked" ),
    RADIO_CHECKED2( "radio-checked2" ),
    RADIO_UNCHECKED( "radio-unchecked" ),
    CROP( "crop" ),
    MAKE_GROUP( "make-group" ),
    UNGROUP( "ungroup" ),
    SCISSORS( "scissors" ),
    FILTER( "filter" ),
    FONT( "font" ),
    LIGATURE( "ligature" ),
    LIGATURE2( "ligature2" ),
    TEXT_HEIGHT( "text-height" ),
    TEXT_WIDTH( "text-width" ),
    FONT_SIZE( "font-size" ),
    BOLD( "bold" ),
    UNDERLINE( "underline" ),
    ITALIC( "italic" ),
    STRIKETHROUGH( "strikethrough" ),
    OMEGA( "omega" ),
    SIGMA( "sigma" ),
    PAGE_BREAK( "page-break" ),
    SUPERSCRIPT( "superscript" ),
    SUBSCRIPT( "subscript" ),
    SUPERSCRIPT2( "superscript2" ),
    SUBSCRIPT2( "subscript2" ),
    TEXT_COLOR( "text-color" ),
    PAGEBREAK( "pagebreak" ),
    CLEAR_FORMATTING( "clear-formatting" ),
    TABLE( "table" ),
    TABLE2( "table2" ),
    INSERT_TEMPLATE( "insert-template" ),
    PILCROW( "pilcrow" ),
    LTR( "ltr" ),
    RTL( "rtl" ),
    SECTION( "section" ),
    PARAGRAPH_LEFT( "paragraph-left" ),
    PARAGRAPH_CENTER( "paragraph-center" ),
    PARAGRAPH_RIGHT( "paragraph-right" ),
    PARAGRAPH_JUSTIFY( "paragraph-justify" ),
    INDENT_INCREASE( "indent-increase" ),
    INDENT_DECREASE( "indent-decrease" ),
    SHARE( "share" ),
    NEW_TAB( "new-tab" ),
    EMBED( "embed" ),
    EMBED2( "embed2" ),
    TERMINAL( "terminal" ),
    SHARE2( "share2" ),
    MAIL( "mail" ),
    MAIL2( "mail2" ),
    MAIL3( "mail3" ),
    MAIL4( "mail4" ),
    AMAZON( "amazon" ),
    GOOGLE( "google" ),
    GOOGLE2( "google2" ),
    GOOGLE3( "google3" ),
    GOOGLE_PLUS( "google-plus" ),
    GOOGLE_PLUS2( "google-plus2" ),
    GOOGLE_PLUS3( "google-plus3" ),
    HANGOUTS( "hangouts" ),
    GOOGLE_DRIVE( "google-drive" ),
    FACEBOOK( "facebook" ),
    FACEBOOK2( "facebook2" ),
    INSTAGRAM( "instagram" ),
    WHATSAPP( "whatsapp" ),
    SPOTIFY( "spotify" ),
    TELEGRAM( "telegram" ),
    TWITTER( "twitter" ),
    VINE( "vine" ),
    VK( "vk" ),
    RENREN( "renren" ),
    SINA_WEIBO( "sina-weibo" ),
    RSS( "rss" ),
    RSS2( "rss2" ),
    YOUTUBE( "youtube" ),
    YOUTUBE2( "youtube2" ),
    TWITCH( "twitch" ),
    VIMEO( "vimeo" ),
    VIMEO2( "vimeo2" ),
    LANYRD( "lanyrd" ),
    FLICKR( "flickr" ),
    FLICKR2( "flickr2" ),
    FLICKR3( "flickr3" ),
    FLICKR4( "flickr4" ),
    DRIBBBLE( "dribbble" ),
    BEHANCE( "behance" ),
    BEHANCE2( "behance2" ),
    DEVIANTART( "deviantart" ),
    ICON_500PX( "500px" ),
    STEAM( "steam" ),
    STEAM2( "steam2" ),
    DROPBOX( "dropbox" ),
    ONEDRIVE( "onedrive" ),
    GITHUB( "github" ),
    NPM( "npm" ),
    BASECAMP( "basecamp" ),
    TRELLO( "trello" ),
    WORDPRESS( "wordpress" ),
    JOOMLA( "joomla" ),
    ELLO( "ello" ),
    BLOGGER( "blogger" ),
    BLOGGER2( "blogger2" ),
    TUMBLR( "tumblr" ),
    TUMBLR2( "tumblr2" ),
    YAHOO( "yahoo" ),
    YAHOO2( "yahoo2" ),
    TUX( "tux" ),
    APPLEINC( "appleinc" ),
    FINDER( "finder" ),
    ANDROID( "android" ),
    WINDOWS( "windows" ),
    WINDOWS8( "windows8" ),
    SOUNDCLOUD( "soundcloud" ),
    SOUNDCLOUD2( "soundcloud2" ),
    SKYPE( "skype" ),
    REDDIT( "reddit" ),
    HACKERNEWS( "hackernews" ),
    WIKIPEDIA( "wikipedia" ),
    LINKEDIN( "linkedin" ),
    LINKEDIN2( "linkedin2" ),
    LASTFM( "lastfm" ),
    LASTFM2( "lastfm2" ),
    DELICIOUS( "delicious" ),
    STUMBLEUPON( "stumbleupon" ),
    STUMBLEUPON2( "stumbleupon2" ),
    STACKOVERFLOW( "stackoverflow" ),
    PINTEREST( "pinterest" ),
    PINTEREST2( "pinterest2" ),
    XING( "xing" ),
    XING2( "xing2" ),
    FLATTR( "flattr" ),
    FOURSQUARE( "foursquare" ),
    YELP( "yelp" ),
    PAYPAL( "paypal" ),
    CHROME( "chrome" ),
    FIREFOX( "firefox" ),
    IE( "IE" ),
    EDGE( "edge" ),
    SAFARI( "safari" ),
    OPERA( "opera" ),
    FILE_PDF( "file-pdf" ),
    FILE_OPENOFFICE( "file-openoffice" ),
    FILE_WORD( "file-word" ),
    FILE_EXCEL( "file-excel" ),
    LIBREOFFICE( "libreoffice" ),
    HTML_FIVE( "html-five" ),
    HTML_FIVE2( "html-five2" ),
    CSS3( "css3" ),
    GIT( "git" ),
    CODEPEN( "codepen" ),
    SVG( "svg" ),
    ICOMOON( "IcoMoon" );

    private static final String ICON_NAME = "%s:%s";

    private static final String ICON_NAME_SEPARATOR = ":";

    public static final String ICON_COLLECTION_NAME = "icomoon";

    public static final String ICON_DESCRIPTION = "Icomoon";

    private String name;

    IcomoonIcon( String name )
    {
        this.name = name;
    }

    @SuppressWarnings( "deprecation" )
    public Icon create()
    {
        return new Icon( ICON_COLLECTION_NAME, name );
    }

    public String getIconName()
    {
        return String.format( ICON_NAME, ICON_COLLECTION_NAME, name );
    }

    public String getIconCollectionName( String iconName )
    {
        return iconName.split( ICON_NAME_SEPARATOR )[0];
    }


}
